Package com.sas.metadata.remote

# Interface ExternalIdentity

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface ExternalIdentity extends SecondaryType
This is an ID associated with the object in some other context, such as a GUID or DN for LDAP .

Attributes of ExternalIdentity are:

- `Context`
- `Identifier`
- `ImportType`

Associations of ExternalIdentity are:

- `OwningObject`

## Usage

To create an instance of this ExternalIdentity, use the `factory` create methods.
Example: create a ExternalIdentity with name "ExternalIdentity_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     ExternalIdentity myObject = (ExternalIdentity) factory.createComplexMetadataObject(objectStore, "ExternalIdentity_Object", MetadataObjects.EXTERNALIDENTITY, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_OWNINGOBJECT_NAME`
  Constant used for the name of the OwningObject association.
  `static final String`
  `ATTRIBUTE_CONTEXT_NAME`
  Constant used for the name of the Context attribute.
  `static final String`
  `ATTRIBUTE_IDENTIFIER_NAME`
  Constant used for the name of the Identifier attribute.
  `static final String`
  `ATTRIBUTE_IMPORTTYPE_NAME`
  Constant used for the name of the ImportType attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getContext()`
  Gets the `String` value of `Context`
  `int`
  `getContextMaxLength()`
  Gets the maximum length of `Context`
  `int`
  `getContextState()`
  Gets the Metadata State of `Context`
  `String`
  `getIdentifier()`
  Gets the `String` value of `Identifier`
  `int`
  `getIdentifierMaxLength()`
  Gets the maximum length of `Identifier`
  `int`
  `getIdentifierState()`
  Gets the Metadata State of `Identifier`
  `String`
  `getImportType()`
  Gets the `String` value of `ImportType`
  `int`
  `getImportTypeMaxLength()`
  Gets the maximum length of `ImportType`
  `int`
  `getImportTypeState()`
  Gets the Metadata State of `ImportType`
  `Root`
  `getOwningObject()`
  Gets the `Root` for `OwningObject`
  `AssociationList`
  `getOwningObjects()`
  Gets the AssociationList of `OwningObjects`
  `AssociationList`
  `getOwningObjects(boolean fGoToServer)`
  Gets the Associationlist of `OwningObjects`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `OwningObject`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `OwningObject`
  `void`
  `setContext(String inContext)`
  Sets the `Context` value and sets the state to MetadataState.LOCAL.
  `void`
  `setContext(String inContext, int state)`
  Sets the `Context` Metadata State.
  `void`
  `setContextState(int state)`
  Sets the Metadata State of `Context`.
  `void`
  `setIdentifier(String inIdentifier)`
  Sets the `Identifier` value and sets the state to MetadataState.LOCAL.
  `void`
  `setIdentifier(String inIdentifier, int state)`
  Sets the `Identifier` Metadata State.
  `void`
  `setIdentifierState(int state)`
  Sets the Metadata State of `Identifier`.
  `void`
  `setImportType(String inImportType)`
  Sets the `ImportType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setImportType(String inImportType, int state)`
  Sets the `ImportType` Metadata State.
  `void`
  `setImportTypeState(int state)`
  Sets the Metadata State of `ImportType`.
  `void`
  `setOwningObject(Root inObject)`
  Sets the `OwningObjects` list 0th element to be `inObject`.
  `void`
  `setOwningObjects(AssociationList list)`
  Sets the `OwningObjects` list to be `list`.
  `void`
  `setOwningObjects(AssociationList list, int state)`
  Sets the `OwningObjects` list to be `list`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_CONTEXT_NAME

    static final String ATTRIBUTE_CONTEXT_NAME
    Constant used for the name of the Context attribute.

    Context: The context for this ID, such as GUID, LDAP DN, or OM repository ID.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_IDENTIFIER_NAME

    static final String ATTRIBUTE_IDENTIFIER_NAME
    Constant used for the name of the Identifier attribute.

    Identifier: The identifier in the originating context.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_IMPORTTYPE_NAME

    static final String ATTRIBUTE_IMPORTTYPE_NAME
    Constant used for the name of the ImportType attribute.

    ImportType: How the owning object was created. such as Copy, Import

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OWNINGOBJECT_NAME

    static final String ASSOCIATION_OWNINGOBJECT_NAME
    Constant used for the name of the OwningObject association.

    OwningObject: The object that had this ID in another context.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    `OwningObject`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `OwningObject`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getContext

    String getContext() throws RemoteException
    Gets the `String` value of `Context`
    Returns:
      The `Context`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getContextState

    int getContextState() throws RemoteException
    Gets the Metadata State of `Context`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getContextMaxLength

    int getContextMaxLength() throws RemoteException
    Gets the maximum length of `Context`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIdentifier

    String getIdentifier() throws RemoteException
    Gets the `String` value of `Identifier`
    Returns:
      The `Identifier`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIdentifierState

    int getIdentifierState() throws RemoteException
    Gets the Metadata State of `Identifier`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getIdentifierMaxLength

    int getIdentifierMaxLength() throws RemoteException
    Gets the maximum length of `Identifier`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getImportType

    String getImportType() throws RemoteException
    Gets the `String` value of `ImportType`
    Returns:
      The `ImportType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getImportTypeState

    int getImportTypeState() throws RemoteException
    Gets the Metadata State of `ImportType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getImportTypeMaxLength

    int getImportTypeMaxLength() throws RemoteException
    Gets the maximum length of `ImportType`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getOwningObjects

    AssociationList getOwningObjects() throws RemoteException, MdException
    Gets the AssociationList of `OwningObjects`
    Returns:
      Returns the AssociationList of `OwningObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getOwningObject

    Root getOwningObject() throws RemoteException, MdException
    Gets the `Root` for `OwningObject`
    Returns:
      The `Root` ( `null` if not set) of `OwningObject`which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningObjects

    AssociationList getOwningObjects(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OwningObjects`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `OwningObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setContext

    void setContext(String inContext) throws RemoteException
    Sets the `Context` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inContext` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setContext

    void setContext(String inContext, int state) throws RemoteException
    Sets the `Context` Metadata State.
    Parameters:
      `inContext` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setContextState

    void setContextState(int state) throws RemoteException
    Sets the Metadata State of `Context`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIdentifier

    void setIdentifier(String inIdentifier) throws RemoteException
    Sets the `Identifier` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inIdentifier` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIdentifier

    void setIdentifier(String inIdentifier, int state) throws RemoteException
    Sets the `Identifier` Metadata State.
    Parameters:
      `inIdentifier` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setIdentifierState

    void setIdentifierState(int state) throws RemoteException
    Sets the Metadata State of `Identifier`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setImportType

    void setImportType(String inImportType) throws RemoteException
    Sets the `ImportType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inImportType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setImportType

    void setImportType(String inImportType, int state) throws RemoteException
    Sets the `ImportType` Metadata State.
    Parameters:
      `inImportType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setImportTypeState

    void setImportTypeState(int state) throws RemoteException
    Sets the Metadata State of `ImportType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningObjects

    void setOwningObjects(AssociationList list) throws RemoteException
    Sets the `OwningObjects` list to be `list`. Object of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningObjects

    void setOwningObjects(AssociationList list, int state) throws RemoteException
    Sets the `OwningObjects` list to be `list`. Object of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningObject

    void setOwningObject(Root inObject) throws RemoteException
    Sets the `OwningObjects` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Root
    Throws:
      `RemoteException` - If error communicating with remote object.